"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const JWS_js_1 = __importDefault(require("./JWS.js"));
const JWE_js_1 = __importDefault(require("./JWE.js"));
function jwtEncrypt(data, keyId, publicKey, privateKey) {
    const signed = JWS_js_1.default.sign(data, keyId, privateKey);
    return JWE_js_1.default.encrypt(JSON.stringify(signed), keyId, publicKey);
}
function jwtDecrypt(data, keyId, publicKey, privateKey) {
    const signed = JWE_js_1.default.decrypt(data, privateKey);
    return JWS_js_1.default.verify(signed, publicKey);
}
exports.default = {
    jwtEncrypt,
    jwtDecrypt,
};
//# sourceMappingURL=JWT.js.map