"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const crypto_1 = __importDefault(require("crypto"));
const JuspayCryptoError_js_1 = __importDefault(require("./JuspayCryptoError.js"));
function readPublicKey(keyString) {
    if (keyString == undefined) {
        throw new JuspayCryptoError_js_1.default('Public key cannot be undefined', 'IllegalPublicKey');
    }
    try {
        return crypto_1.default.createPublicKey({
            key: keyString,
            format: 'pem',
        });
    }
    catch (error) {
        throw new JuspayCryptoError_js_1.default(error, 'IllegalPublicKey');
    }
}
function readPrivateKey(keyString) {
    if (keyString == undefined) {
        throw new JuspayCryptoError_js_1.default('Private key cannot be undefined', 'IllegalPrivateKey');
    }
    try {
        return crypto_1.default.createPrivateKey({
            key: keyString,
            format: 'pem',
        });
    }
    catch (error) {
        throw new JuspayCryptoError_js_1.default(error, 'IllegalPrivateKey');
    }
}
exports.default = {
    readPublicKey,
    readPrivateKey,
};
//# sourceMappingURL=Keys.js.map