function encodeBase64Url(original) {
    return encodeBase64UrlFromBuffer(Buffer.from(original));
}
function encodeBase64UrlFromBuffer(buffer) {
    return buffer
        .toString('base64')
        .replace(/\+/g, '-')
        .replace(/\//g, '_')
        .replace(/=/g, '');
}
function decodeBase64Url(base64url) {
    return decodeBase64UrlToBuffer(base64url).toString();
}
function decodeBase64UrlToBuffer(base64url) {
    // const base64 = base64url.replace(/-/g, '+').replace(/_/g, '/')
    // return Buffer.from(base64, 'base64')
    return Buffer.from(base64url, 'base64');
}
export default {
    encodeBase64UrlFromBuffer: encodeBase64UrlFromBuffer,
    encodeBase64Url: encodeBase64Url,
    decodeBase64Url: decodeBase64Url,
    decodeBase64UrlToBuffer: decodeBase64UrlToBuffer
};
//# sourceMappingURL=Utils.js.map