import JuspayResource from '../JuspayResource.js';
import { JuspayEnvironment } from '../JuspayEnvironment.js';
import { CreateSessionRequest, HttpResponse, JuspayConfig } from '../types/index.js';
export default class OrderSession extends JuspayResource {
    constructor(juspayEnvironment: JuspayEnvironment);
    /**
     * This is a Server-to-Server API that takes order parameters as an input and returns the SDK payload and the payment link. This also creates order in the Juspay system.
     * @param body order session body
     * @param juspayConfig override config using this params usage:- {apiKey: '', merchantId: '', ...}
     * @returns Promise Response Object
     *
     * @link https://docs.juspay.in/hyper-checkout/android/base-sdk-integration/session
     */
    create(body: CreateSessionRequest, juspayConfig?: JuspayConfig): Promise<HttpResponse>;
}
