/// <reference types="node" />
import crypto from 'crypto';
type JWEToken = {
    header: string;
    encryptedKey: string;
    iv: string;
    encryptedPayload: string;
    tag: string;
};
declare function encrypt(data: string, keyId: string, publicKey: crypto.KeyObject): JWEToken;
declare function decrypt(cipher: string | JWEToken, privateKey: crypto.KeyObject): string;
export type { JWEToken };
declare const _default: {
    encrypt: typeof encrypt;
    decrypt: typeof decrypt;
};
export default _default;
