/// <reference types="node" />
import crypto from 'crypto';
type JWSSigned = {
    signature: string;
    header: string;
    payload: string;
};
declare function sign(claims: string, keyId: string, privateKey: crypto.KeyObject): JWSSigned;
declare function verify(signed: string | JWSSigned, publicKey: crypto.KeyObject): string;
export type { JWSSigned };
declare const _default: {
    sign: typeof sign;
    verify: typeof verify;
};
export default _default;
