/// <reference types="node" />
import crypto from 'crypto';
import { JWEToken } from './JWE.js';
declare function jwtEncrypt(data: string, keyId: string, publicKey: crypto.KeyObject, privateKey: crypto.KeyObject): JWEToken;
declare function jwtDecrypt(data: string | JWEToken, keyId: string, publicKey: crypto.KeyObject, privateKey: crypto.KeyObject): string;
export type JWTKeys = {
    keyId: string;
    publicKey: crypto.KeyObject;
    privateKey: crypto.KeyObject;
};
declare const _default: {
    jwtEncrypt: typeof jwtEncrypt;
    jwtDecrypt: typeof jwtDecrypt;
};
export default _default;
